------------------------------------------------------------------------------------------------------
-- BattleCry Localization Translations & Environment Variables
-- 
-- Version 3.0
------------------------------------------------------------------------------------------------------
BC_Vars = {}
BC_UI = {}
BC_UI.AddOnName = "BattleCry"

BC_Vars.AddOnName = "BattleCry"
BC_Vars.DebugLevel = 0
BC_Vars.Version = 3.0
BC_Vars.echo = false

BC_Vars.Title = BC_Vars.AddOnName .. " Version " .. tostring(BC_Vars.Version)

BC_Vars.Condition = {
	Variables = {
		"$nm", "$hm", "$hc", "$hp", "$mm", "$mc", "$mp",
		"$cl", "$cc", "$cf", "$ct", "$fa", "$rc", "$lv",
		"$sx", "$gu", "$pv", "$ic", "$ip", "$ir", "$re", "$cv",
		"$pn", "$po", "$pp", "$ps", "$ga", "$gb",
		"$e#", "$h1", "$h2", "$h3", "$zn"},
	Functions = {
		"UnitName", "UnitHealthMax", "UnitHealth", "BC_Conditions.UnitHealthPercent",
		"UnitManaMax", "UnitMana", "BC_Conditions.UnitManaPercent",
		"UnitClass", "UnitClassification", "UnitCreatureFamily", "UnitCreatureType",
		"UnitFactionGroup", "UnitRace", "UnitLevel",
		"UnitSex", "BC_Core.UnitGuildName", "UnitIsPVP", "UnitAffectingCombat",
		"BC_Conditions.UnitInParty", "BC_Conditions.UnitInRaid", "BC_Conditions.UnitReaction", 
		"UnitIsCivilian", "UnitName", "UnitSex", "UnitSex",
		"UnitSex", "UnitSex", "UnitSex",
		"BC_Events.ReturnVariable", "BC_Conditions.UnitItemMH", "BC_Conditions.UnitItemOH", "BC_Conditions.UnitItemRW",
		"GetZoneText"},
	Types = {
		1,2,2,2,
		2,2,2,
		1,1,1,1,
		1,1,2,
		2,1,3,3,
		3,3,2,
		3,2,2,2,
		2,2,2,
		1,1,1,1,
		1},
	Targets = { "player", "pet", "target", "focus", "event", },
	Tests = { "==", "<", "<=", ">", ">=", "~=", "Co", "co", },
}

if(GetLocale() == "deDE") then
-----------------------------------------------
-- GERMAN  VERSION TEXTS -- Many thanks to Mergan for German translation
------------------------------------------------
		-- Variables							-- Examples
	BC_Vars.Pronouns = {
		Subject = { "es", "er", "sie" },		-- It took the ball. He is running away. She has red hair.
		Object = { "sein", "sein", "ihr" },		-- That belongs to it. I don't see him. There's no room for her.
		Possessive = { "sein", "seins", "ihrs" },		-- Don't touch its tail. I can read his mind. The dress is hers.
		Gender1 = { "es", "Männlich", "Weiblich" },
		Gender2 = { "es", "Mann", "Frau" },
	}

	BC_Vars.PetActions = {
		Attack = "Pet Attack",
		Follow = "Pet Follow",
		Wait = "Pet Stay",
		Aggressive = "Pet Aggressive",
		Defensive = "Pet Defensive",
		Passive = "Pet Passive",
	}


elseif(GetLocale() == "frFR") then
------------------------------------------------
-- FRENCH  VERSION TEXTS -- Many thanks to Helghast for French translation
------------------------------------------------
		-- Variables							-- Examples
	BC_Vars.Pronouns = {
		Subject = { "ça", "il", "elle" },		-- It took the ball. He is running away. She has red hair.
		Object = { "it", "him", "her" },		-- That belongs to it. I don't see him. There's no room for her.
		Possessive = { "son", "son", "sa" },		-- Don't touch its tail. I can read his mind. The dress is hers.
		Gender1 = { "il", "mâle", "femelle" },
		Gender2 = { "il", "homme", "femme" },
	}

	BC_Vars.PetActions = {
		Attack = "Pet Attack",
		Follow = "Pet Follow",
		Wait = "Pet Stay",
		Aggressive = "Pet Aggressive",
		Defensive = "Pet Defensive",
		Passive = "Pet Passive",
	}

else
	BC_Vars.Pronouns = {
		Subject = { "it", "he", "she" },		-- It took the ball. He is running away. She has red hair.
		Object = { "it", "him", "her" },		-- That belongs to it. I don't see him. There's no room for her.
		Possessive = { "its", "his", "hers" },		-- Don't touch its tail. I can read his mind. The dress is hers.
		Gender1 = { "it", "male", "female" },
		Gender2 = { "it", "man", "woman" },
	}

	BC_Vars.PetActions = {
		Attack = "Pet Attack",
		Follow = "Pet Follow",
		Wait = "Pet Stay",
		Aggressive = "Pet Aggressive",
		Defensive = "Pet Defensive",
		Passive = "Pet Passive",
	}

end