BC_Editor = {}
BC_EditorUI = {}

------------------------------------------------------
--
--	Frame Functions
--
------------------------------------------------------
function BC_EditorFrame_OnLoad()
	getglobal(this:GetName() .. "_TitleText"):SetText(BC_Vars.Title)

	BC_EditorUI.TabEventsButton = BC_UI.TabButton:new("Events", "Events", 1)
	BC_EditorUI.TabEventsButton.frame:Show()
	BC_EditorUI.TabEventsButton.frame:SetPoint("BOTTOMRIGHT", this, "BOTTOMRIGHT", -20, 14)
	BC_EditorUI.TabChainsButton = BC_UI.TabButton:new("Chains", "Chains", 2)
	BC_EditorUI.TabChainsButton.frame:Show()
	BC_EditorUI.TabChainsButton.frame:SetPoint("RIGHT", BC_EditorUI.TabEventsButton.frame, "LEFT", 2, 0)
	BC_EditorUI.TabCriesButton = BC_UI.TabButton:new("Cries", "Cries", 3)
	BC_EditorUI.TabCriesButton.frame:Show()
	BC_EditorUI.TabCriesButton.frame:SetPoint("RIGHT", BC_EditorUI.TabChainsButton.frame, "LEFT", 2, 0)

	PanelTemplates_SetNumTabs(this, 3);
	PanelTemplates_SetTab(this, 3);

	BC_Core.Message(BC_Vars.AddOnName .. " Editor Loaded.")
--	BC_EventWatchFrame:Show()
end

function BC_EditorFrame_OnHide()
	BC_Core.Message("BC_EditorFrame_OnHide()", 2)
end

function BC_EditorFrame_OnEvent()
	DEFAULT_CHAT_FRAME:AddMessage("Editor Event", 2)
end

------------------------------------------------------
--
--	Edit Cries
--
------------------------------------------------------

function BC_EditorFrame_Cries_OnLoad()
--	The following line shouldn't call on load, but on first show
--	BC_Editor.CryNew()
end

function BC_EditorFrame_Cries_OnShow()
	BC_Core.Message("BC_EditorFrame_Cries_OnShow()", 2)
	BC_EditorUI.CryCategoryScroll.frame:GetParent():Show()
	BC_EditorUI.CryCategoryScroll.frame:Show()
end

function BC_CategoryFrame_OnLoad()
	getglobal(this:GetName() .. "_TitleText"):SetText(BC_UI.Variables.Labels.Categories)
	BC_EditorUI.CryCategoryScroll = BC_UI.ScrollPanel:new("CryCategory", 5, {}, BC_Editor.SelectCategory)
	BC_EditorUI.CryCategoryScroll.frame:SetPoint("TOPLEFT", this, "TOPLEFT", 0, -10)

	BC_EditorUI.CryCategoryScroll.list = BC_Editor.GetCategories()

	BC_Core.Message(this:GetName() .. " Loaded.", 3)
end

function BC_CategoryEditFrame_OnLoad()
	getglobal(this:GetName() .. "_TitleText"):SetText(BC_UI.Variables.Category.Custom)

	BC_EditorUI.CustomDeleteButton = BC_UI.Button:new("CustomDelete", BC_UI.Variables.Labels.Delete, BC_Editor.CustomActionDelete)
	BC_EditorUI.CustomDeleteButton.frame:SetPoint("BOTTOM", this, "BOTTOM", 0, 10)
	BC_EditorUI.CustomDeleteButton.frame:SetWidth(80)

	BC_EditorUI.CustomSaveButton = BC_UI.Button:new("CustomSave", BC_UI.Variables.Labels.Save, BC_Editor.CustomActionSave)
	BC_EditorUI.CustomSaveButton.frame:SetPoint("TOPRIGHT", this, "TOPRIGHT", -10, -20)
	BC_EditorUI.CustomSaveButton.frame:SetWidth(65)
	BC_EditorUI.CustomSaveButton.frame:Show()

	BC_EditorUI.CustomName = BC_UI.EditBox:new("CustomName", BC_UI.Variables.Labels.Name, "", 95)
	BC_EditorUI.CustomName.frame:SetPoint("TOPLEFT", this, "TOPLEFT", 10, -15)
	BC_EditorUI.CustomName.frame:Show()

	BC_Core.Message(this:GetName() .. " Loaded.", 3)
end

function BC_ActionFrame_OnLoad()
	getglobal(this:GetName() .. "_TitleText"):SetText(BC_UI.Variables.Labels.Actions)
	BC_EditorUI.ActionScroll = BC_UI.ScrollPanel:new("Action", 6, {}, BC_Editor.SelectAction)
	BC_EditorUI.ActionScroll.frame:SetPoint("TOPLEFT", this, "TOPLEFT", 0, -10)
	BC_EditorUI.ActionScroll.frame:Show()

	BC_EditorUI.ActionFrequency = BC_UI.HSlider:new("Frequency", BC_UI.Variables.Labels.Frequency, 0, 100, 1, 50)
	BC_EditorUI.ActionFrequency.frame:SetPoint("BOTTOM", this, "BOTTOM", 0, 45)

	BC_EditorUI.ActionCooldown = BC_UI.EditBox:new("Cooldown", BC_UI.Variables.Labels.Cooldown, "0", 30)
	BC_EditorUI.ActionCooldown.frame:SetPoint("BOTTOMRIGHT", this, "BOTTOMRIGHT", -15, 5)
	BC_EditorUI.ActionCooldown.frame:SetNumeric(true)
	BC_EditorUI.ActionCooldown.label:ClearAllPoints()
	BC_EditorUI.ActionCooldown.label:SetPoint("RIGHT", BC_EditorUI.ActionCooldown.frame, "LEFT", -35, 5)

	BC_EditorUI.ActionSave = BC_UI.Button:new("Save", BC_UI.Variables.Labels.Save, BC_Editor.ActionSave)
	BC_EditorUI.ActionSave.frame:SetPoint("BOTTOMLEFT", this, "BOTTOMLEFT", 10, 10)
	BC_EditorUI.ActionSave.frame:SetWidth(60)
	BC_EditorUI.ActionSave.frame:Show()

	BC_Core.Message(this:GetName() .. " Loaded.", 3)
end

function BC_CryFrame_OnLoad()
	getglobal(this:GetName() .. "_TitleText"):SetText(BC_UI.Variables.Labels.Cries)
	BC_EditorUI.SavedCryScroll = BC_UI.ScrollPanel:new("SavedCry", 9, {}, BC_Editor.SelectCry)
	BC_EditorUI.SavedCryScroll.frame:SetPoint("TOPLEFT", this, "TOPLEFT", 0, -10)
	BC_EditorUI.SavedCryScroll.frame:Show()

	BC_EditorUI.CryDeleteButton = BC_UI.Button:new("Delete", BC_UI.Variables.Labels.Delete, BC_Editor.CryDelete)
	BC_EditorUI.CryDeleteButton.frame:SetPoint("BOTTOM", this, "BOTTOM", 0, 10)
	BC_EditorUI.CryDeleteButton.frame:SetWidth(80)
	BC_EditorUI.CryDeleteButton.frame:Show()

	BC_Core.Message(this:GetName() .. " Loaded.", 3)
end

function BC_CryEditFrame_OnLoad()
	getglobal(this:GetName() .. "_TitleText"):SetText(BC_UI.Variables.Labels.EditCry)
	BC_EditorUI.CryName = BC_UI.EditBox:new("CryName", BC_UI.Variables.Labels.CryName, "", 120)
	BC_EditorUI.CryName.frame:SetPoint("TOPLEFT", this, "TOPLEFT", 15, -15)
	BC_EditorUI.CryName.frame:Show()

	BC_EditorUI.CryText = BC_UI.EditBoxScroll:new("CryText", BC_UI.Variables.Labels.CryText, "", 350, 100)
	BC_EditorUI.CryText.frame:SetPoint("TOPLEFT", this, "TOPLEFT", 10, -57)
	BC_EditorUI.CryText.frame:Show()

	BC_EditorUI.CryMult = BC_UI.HSlider:new("Multiplier", BC_UI.Variables.Labels.Multiplier, 1, 10, 1, 1)
	BC_EditorUI.CryMult.frame:SetPoint("TOPRIGHT", this, "TOPRIGHT", -10, -20)
	BC_EditorUI.CryMult.frame:Show()

	BC_EditorUI.CryAlways = BC_UI.CheckButton:new("Always", 0, BC_UI.Variables.Labels.Always)
	BC_EditorUI.CryAlways.frame:SetPoint("TOPLEFT", BC_EditorUI.CryMult.frame, "BOTTOMLEFT", -5, -15)
	BC_EditorUI.CryAlways.frame:Show()

	BC_EditorUI.CryExclude = BC_UI.CheckButton:new("Exclude", 0, BC_UI.Variables.Labels.Exclude)
	BC_EditorUI.CryExclude.frame:SetPoint("TOPLEFT", BC_EditorUI.CryAlways.frame, "BOTTOMLEFT", 0, 10)
	BC_EditorUI.CryExclude.frame:Show()

	BC_EditorUI.CryTiming = BC_UI.DropDown:new("Timing", BC_UI.Variables.Labels.Timing, 120, BC_Editor.TimingDropDown_Initialize)
	BC_EditorUI.CryTiming.frame:SetPoint("TOPLEFT", BC_EditorUI.CryExclude.frame, "BOTTOMLEFT", -10, -10)
	BC_EditorUI.CryTiming.frame:Show()

	BC_EditorUI.CryLanguage = BC_UI.DropDown:new("Language", BC_UI.Variables.Labels.Language, 90, BC_Editor.LanguageDropDown_Initialize)
	BC_EditorUI.CryLanguage.frame:SetPoint("TOPLEFT", this, "TOPLEFT", -5, -170)
	BC_EditorUI.CryLanguage.frame:Show()

	BC_EditorUI.CryOutput = BC_UI.DropDown:new("Output", BC_UI.Variables.Labels.OutputModes, 90, BC_Editor.OutputDropDown_Initialize)
	BC_EditorUI.CryOutput.frame:SetPoint("TOPLEFT", this, "TOPLEFT", 110, -170)
	BC_EditorUI.CryOutput.frame:Show()

	BC_EditorUI.CrySaveButton = BC_UI.Button:new("CrySave", BC_UI.Variables.Labels.Save, BC_Editor.CrySave)
	BC_EditorUI.CrySaveButton.frame:SetPoint("BOTTOMRIGHT", this, "BOTTOMRIGHT", -15, 15)
	BC_EditorUI.CrySaveButton.frame:SetWidth(80)
	BC_EditorUI.CrySaveButton.frame:Show()

	BC_EditorUI.CryNewButton = BC_UI.Button:new("CryNew", BC_UI.Variables.Labels.New, BC_Editor.CryNew)
	BC_EditorUI.CryNewButton.frame:SetPoint("BOTTOMRIGHT", this, "BOTTOMRIGHT", -100, 15)
	BC_EditorUI.CryNewButton.frame:SetWidth(80)
	BC_EditorUI.CryNewButton.frame:Show()

	BC_EditorUI.CryTestButton = BC_UI.Button:new("CryTest", BC_UI.Variables.Labels.Test, BC_Editor.CryTest)
	BC_EditorUI.CryTestButton.frame:SetPoint("BOTTOMRIGHT", this, "BOTTOMRIGHT", -235, 15)
	BC_EditorUI.CryTestButton.frame:SetWidth(80)
	BC_EditorUI.CryTestButton.frame:Show()

	BC_EditorUI.CryConditionsButton = BC_UI.Button:new("CryConditions", BC_UI.Variables.Labels.Conditions .. " (0)", BC_Editor.Conditions_Show)
	BC_EditorUI.CryConditionsButton.frame:SetPoint("TOPLEFT", this, "TOPLEFT", 220, -30)
	BC_EditorUI.CryConditionsButton.frame:SetWidth(140)
	BC_EditorUI.CryConditionsButton.frame:Show()

	BC_Core.Message(this:GetName() .. " Loaded.", 3)
end

function BC_Editor.GetChains()
	BC_Core.Message("BC_Editor.GetChains()",2);
	local tempList = {}
	for i, u in pairs(BC_Data.cries) do
		for j, v in ipairs(u.cries) do
			if(v.chain) then
				for k, w in pairs(v.chain) do
					for l, x in ipairs(w) do
						BC_Core.Message("Found cry " .. i .. " " .. j .. " " .. k .. " " .. x,3);
						table.insert(tempList, {headAction = i, headCry = j, tailAction = k, tailCry = x})
					end
				end
			end
		end
	end
	return tempList
end

function BC_Editor.GetCategories()
	BC_Core.Message("BC_Editor.GetCategories()",2);
	local categories = {}
	for i=1, MAX_SKILLLINE_TABS do
		name, _, _, numSpells = GetSpellTabInfo(i)
		if not name then
			do break end
		end
		table.insert(categories, name)
	end
	table.insert(categories, BC_UI.Variables.Category.Pet)
	table.insert(categories, BC_UI.Variables.Category.Custom)
	table.insert(categories, BC_UI.Variables.Category.Event)
	return categories
end

function BC_Editor.GetActions(category)
	BC_Core.Message("BC_Editor.GetActions(" .. category .. ")",2);
	local actions = {}
	if(category == BC_UI.Variables.Category.Custom) then
		for i, v in ipairs(BC_Data.custom) do
			table.insert(actions, v)
		end
	elseif(category == BC_UI.Variables.Category.Pet) then
		table.insert(actions, BC_Vars.PetActions.Attack)
		table.insert(actions, BC_Vars.PetActions.Follow)
		table.insert(actions, BC_Vars.PetActions.Wait)
		table.insert(actions, BC_Vars.PetActions.Aggressive)
		table.insert(actions, BC_Vars.PetActions.Defensive)
		table.insert(actions, BC_Vars.PetActions.Passive)
		if(HasPetUI()) then
			for i= 1, NUM_PET_ACTION_SLOTS do
				local actionName, _, _, _, _, _, _ = GetPetActionInfo(i)
				if(actionName) then
					if(actionName ~= "PET_ACTION_ATTACK"
					and actionName ~= "PET_ACTION_FOLLOW"
					and actionName ~= "PET_ACTION_WAIT" 
					and actionName ~= "PET_MODE_AGGRESSIVE" 
					and actionName ~= "PET_MODE_DEFENSIVE" 
					and actionName ~= "PET_MODE_PASSIVE") then
						table.insert(actions, "Pet " .. actionName)
					end
				end
			end
		end
	elseif(category == BC_UI.Variables.Category.Event) then
		for k, v in pairs(BC_Data.events) do
			for i, w in ipairs(v) do
				table.insert(actions, w.name)
			end
		end
	else
		local spellCount = 0
		for i=1, MAX_SKILLLINE_TABS do
			name, _, _, numSpells = GetSpellTabInfo(i)
			if(name ~= category) then
				spellCount = spellCount + numSpells
			else
				for j=1, numSpells do
					actionName, spellRank = GetSpellName(spellCount + j, BOOKTYPE_SPELL)
					if not actionName then
						do break end
					end
					if(IsPassiveSpell(spellCount + j, BOOKTYPE_SPELL)~=1) then
						found = false
						for k, v in ipairs(actions) do
							if(actionName == v) then
								found = true
							end
						end
						if(not found) then
							table.insert(actions, actionName)
						end
					end
				end
			end
		end
	end
	return actions
end

function BC_Editor.GetCries(action)
	BC_Core.Message("BC_Editor.GetCries(" .. action .. ")",2);
	local cries = {}
	if(BC_Data.cries[action]) then
		for i, v in ipairs(BC_Data.cries[action].cries) do
			table.insert(cries, BC_Data.cries[action].cries[i].name)
		end
	end
	return cries
end

function BC_Editor.SelectCategory(index)
	BC_Core.Message("BC_Editor.SelectCategory(" .. index .. ")",2);
	BC_EditorUI.ActionScroll.list = BC_Editor.GetActions(BC_EditorUI.CryCategoryScroll.list[index])
	if(BC_EditorUI.CryCategoryScroll.list[index] == BC_UI.Variables.Category.Custom) then
		BC_EditorUI.CustomName.frame:GetParent():Show()
	else
		BC_EditorUI.CustomName.frame:GetParent():Hide()
	end
	BC_EditorUI.CustomDeleteButton.frame:Hide()
	BC_EditorUI.ActionScroll.selected = 0
	BC_EditorUI.SavedCryScroll.selected = 0
	
	BC_EditorUI.ActionFrequency.frame:Hide()
	BC_EditorUI.ActionCooldown.frame:Hide()
	BC_EditorUI.ActionSave.frame:Hide()

	BC_EditorUI.ActionScroll.frame:GetParent():Show()
	BC_EditorUI.SavedCryScroll.frame:GetParent():Hide()
	BC_EditorUI.CryName.frame:GetParent():Hide()

	BC_EditorUI.ConditionScroll.frame:GetParent():Hide()

	BC_UI.ScrollList_UpdateList(getglobal(BC_EditorUI.ActionScroll.frame:GetName() .. "Scroll"), BC_EditorUI.ActionScroll.size, BC_EditorUI.ActionScroll.list, #(BC_EditorUI.ActionScroll.list), 0)
end

function BC_Editor.SelectAction(index)
	BC_Core.Message("BC_Editor.SelectAction(" .. index .. ")",2);
	local actionName = BC_EditorUI.ActionScroll.list[index]
	if(BC_Data.cries[actionName]) then
		BC_EditorUI.ActionFrequency.frame:SetValue(BC_Data.cries[actionName].freq or 0)
		BC_EditorUI.ActionCooldown.frame:SetText(BC_Data.cries[actionName].cooldown or 0)
	else
		BC_EditorUI.ActionFrequency.frame:SetValue(0)
		BC_EditorUI.ActionCooldown.frame:SetText(0)
	end
	BC_EditorUI.SavedCryScroll.list = BC_Editor.GetCries(actionName)
	BC_EditorUI.SavedCryScroll.selected = 0
	BC_EditorUI.CustomDeleteButton.frame:Show()
	BC_EditorUI.ActionFrequency.frame:Show()
	BC_EditorUI.ActionCooldown.frame:Show()
	BC_EditorUI.ActionSave.frame:Show()
	BC_EditorUI.SavedCryScroll.frame:GetParent():Show()
	BC_EditorUI.CryName.frame:GetParent():Show()
	BC_EditorUI.ConditionScroll.frame:GetParent():Hide()
	BC_UI.ScrollList_UpdateList(getglobal(BC_EditorUI.SavedCryScroll.frame:GetName() .. "Scroll"), BC_EditorUI.SavedCryScroll.size, BC_EditorUI.SavedCryScroll.list, #(BC_EditorUI.SavedCryScroll.list), 0)

	BC_EditorUI.CryDeleteButton.frame:Hide()
	BC_EditorUI.CryConditionsButton.frame:SetText(BC_UI.Variables.Labels.Conditions .. " (0)")
	BC_Editor.Conditions_ButtonDisplay();
end

function BC_Editor.SelectCry(index)
	BC_Core.Message("BC_Editor.SelectCry(" .. index .. ")",2);
	BC_EditorUI.CryName.frame:GetParent():Show()
	BC_EditorUI.CryDeleteButton.frame:Show()
	BC_EditorUI.ConditionScroll.frame:GetParent():Hide()

	local selectedCry = BC_Data.cries[BC_EditorUI.ActionScroll.list[BC_EditorUI.ActionScroll.selected]].cries[BC_EditorUI.SavedCryScroll.selected]
	BC_EditorUI.CryName.frame:SetText(selectedCry.name or "")
	getglobal(BC_EditorUI.CryText.frame:GetName() .. "ScrollChildEditBox"):SetText(selectedCry.text or "")
	BC_EditorUI.CryMult.frame:SetValue(selectedCry.mult or 1)
	BC_EditorUI.CryExclude.frame:SetChecked(selectedCry.exclude or 0)
	BC_Core.Message("Looking for interrupt", 3)
	if(selectedCry.interrupt) then
		UIDropDownMenu_SetSelectedValue(BC_EditorUI.CryTiming.frame, 3)
		UIDropDownMenu_SetText(BC_UI.Variables.Timing[3], BC_EditorUI.CryTiming.frame)
	elseif(selectedCry.start) then
		UIDropDownMenu_SetSelectedValue(BC_EditorUI.CryTiming.frame, 2)
		UIDropDownMenu_SetText(BC_UI.Variables.Timing[2], BC_EditorUI.CryTiming.frame)
	else
		UIDropDownMenu_SetSelectedValue(BC_EditorUI.CryTiming.frame, 1)
		UIDropDownMenu_SetText(BC_UI.Variables.Timing[1], BC_EditorUI.CryTiming.frame)
	end
	BC_Core.Message("Looking for language", 3)
	if(selectedCry.language) then
		UIDropDownMenu_SetSelectedValue(BC_EditorUI.CryLanguage.frame, selectedCry.language)
		UIDropDownMenu_SetText(GetLanguageByIndex(selectedCry.language), BC_EditorUI.CryLanguage.frame)
	else
		UIDropDownMenu_SetSelectedValue(BC_EditorUI.CryLanguage.frame, 1)
		UIDropDownMenu_SetText(GetLanguageByIndex(1), BC_EditorUI.CryLanguage.frame)
	end
	BC_Core.Message("Looking for mode", 3)
	if(selectedCry.mode) then
		UIDropDownMenu_SetSelectedValue(BC_EditorUI.CryOutput.frame, selectedCry.mode)
		UIDropDownMenu_SetText(BC_UI.Variables.OutputModes[selectedCry.mode], BC_EditorUI.CryOutput.frame)
	else
		UIDropDownMenu_SetSelectedValue(BC_EditorUI.CryOutput.frame, 1)
		UIDropDownMenu_SetText(BC_UI.Variables.OutputModes[1], BC_EditorUI.CryOutput.frame)
	end
	BC_Core.Message("Looking for condition", 3)
	if(selectedCry.condition) then
		BC_Core.Message("found", 4)
		BC_EditorUI.ConditionScroll.list = BC_Editor.GetConditions_List(selectedCry.condition)
		BC_EditorUI.ConditionScroll.valueList = selectedCry.condition
	else
		BC_Core.Message("not found", 4)
		BC_EditorUI.ConditionScroll.list = {}
		BC_EditorUI.ConditionScroll.valueList = {}
	end
	BC_Editor.Conditions_ButtonDisplay();
end

function BC_Editor.PrintCryNames()
	local categories = BC_Editor.GetCategories()
	for i, v in pairs(categories) do
		BC_Core.Message(v .. ":")
		local actions = BC_Editor.GetActions(v)
		for j, w in pairs(actions) do
			BC_Core.Message("  " .. w .. ":")
			local cries = BC_Editor.GetCries(w)
			for k, x in pairs(cries) do
				BC_Core.Message("    " .. x)
			end
		end
	end
end

function BC_Editor.ActionSave()
	BC_Core.Message("BC_Editor.ActionSave()", 2)
	local actionName = BC_EditorUI.ActionScroll.list[BC_EditorUI.ActionScroll.selected]
	if(not BC_Data.cries[actionName]) then
		BC_Data.cries[actionName] = {
			cries = {},
		}
	end
	BC_Data.cries[actionName].freq = BC_EditorUI.ActionFrequency.frame:GetValue()
	BC_Data.cries[actionName].cooldown = BC_EditorUI.ActionCooldown.frame:GetNumber()
	BC_Core.Message("Saving [" .. actionName .. "] with frequency " .. BC_Data.cries[actionName].freq .. "% and cooldown " .. BC_Data.cries[actionName].cooldown .. " seconds.")
end

function BC_Editor.CryDelete()
	BC_Core.Message("BC_Editor.CryDelete()", 2)
	table.remove(BC_Data.cries[BC_EditorUI.ActionScroll.list[BC_EditorUI.ActionScroll.selected]].cries, BC_EditorUI.SavedCryScroll.selected) 
	BC_Editor.SelectAction(BC_EditorUI.ActionScroll.selected)
	if(#(BC_EditorUI.SavedCryScroll.list) == 0) then
		if(BC_EditorUI.CryCategoryScroll.list[BC_EditorUI.CryCategoryScroll.selected] == BC_UI.Variables.Category.Event) then
			for k, v in pairs(BC_Data.events) do
				for i, w in ipairs(v) do
					if(w.name == BC_EditorUI.ActionScroll.list[BC_EditorUI.ActionScroll.selected]) then
						BC_Events.Unregister(k)
					end
				end
			end
		end
		BC_Data.cries[BC_EditorUI.ActionScroll.list[BC_EditorUI.ActionScroll.selected]] = nil
	end
end

function BC_Editor.CrySave()
	BC_Core.Message("BC_Editor.CrySave()", 2)
	local actionName = BC_EditorUI.ActionScroll.list[BC_EditorUI.ActionScroll.selected]
	local cryName = BC_EditorUI.CryName.frame:GetText()
	local found = 0
	if(not BC_Data.cries[actionName]) then
		BC_Editor.ActionSave()
		if(BC_EditorUI.CryCategoryScroll.list[BC_EditorUI.CryCategoryScroll.selected] == BC_UI.Variables.Category.Event) then
			for k, v in pairs(BC_Data.events) do
				for i, w in ipairs(v) do
					if(w.name == actionName) then
						BC_Events.Register(k)
					end
				end
			end
		end
	end
	for i=1, #(BC_Data.cries[actionName].cries) do
		if(BC_Data.cries[actionName].cries[i].name == cryName) then
			found = i
		end
	end
	if(found>0) then
		BC_Data.cries[actionName].cries[found] = {
			name = cryName,
			text = getglobal(BC_EditorUI.CryText.frame:GetName() .. "ScrollChildEditBox"):GetText(),
			mult = BC_EditorUI.CryMult.frame:GetValue(),
			language = UIDropDownMenu_GetSelectedValue(BC_EditorUI.CryLanguage.frame),
			mode = UIDropDownMenu_GetSelectedValue(BC_EditorUI.CryOutput.frame),
		}
	else
		table.insert(BC_Data.cries[actionName].cries, 
		{
			name = cryName,
			text = getglobal(BC_EditorUI.CryText.frame:GetName() .. "ScrollChildEditBox"):GetText(),
			mult = BC_EditorUI.CryMult.frame:GetValue(),
			language = UIDropDownMenu_GetSelectedValue(BC_EditorUI.CryLanguage.frame),
			mode = UIDropDownMenu_GetSelectedValue(BC_EditorUI.CryOutput.frame),
		})
		found = #(BC_Data.cries[actionName].cries)
		BC_EditorUI.SavedCryScroll.list = BC_Editor.GetCries(actionName)
		BC_EditorUI.SavedCryScroll.selected = 0
		BC_UI.ScrollList_UpdateList(getglobal(BC_EditorUI.SavedCryScroll.frame:GetName() .. "Scroll"), BC_EditorUI.SavedCryScroll.size, BC_EditorUI.SavedCryScroll.list, #(BC_EditorUI.SavedCryScroll.list), 0)
	end
	if(UIDropDownMenu_GetSelectedValue(BC_EditorUI.CryTiming.frame)==2) then
		BC_Data.cries[actionName].cries[found].start = true
	elseif(UIDropDownMenu_GetSelectedValue(BC_EditorUI.CryTiming.frame)==3) then
		BC_Data.cries[actionName].cries[found].interrupt = true
	end
	BC_Data.cries[actionName].cries[found].always = BC_EditorUI.CryAlways.frame:GetChecked()
	BC_Data.cries[actionName].cries[found].exclude = BC_EditorUI.CryExclude.frame:GetChecked()
	BC_Data.cries[actionName].cries[found].condition = BC_EditorUI.ConditionScroll.valueList
	BC_Core.Message("Cry '" .. cryName .. "' saved to action [" .. actionName .. "].")
end

function BC_Editor.CryTest()
	BC_Core.Message("BC_Editor.CryTest()", 2)
	local thisCry = {
		text = getglobal(BC_EditorUI.CryText.frame:GetName() .. "ScrollChildEditBox"):GetText(),
		mode = UIDropDownMenu_GetSelectedValue(BC_EditorUI.CryOutput.frame),
		language = UIDropDownMenu_GetSelectedValue(BC_EditorUI.CryLanguage.frame),
	}
	local newCry = BC_Core.FormatCry(thisCry)
	BC_Core.SendCry(newCry)
end

function BC_Editor.CryNew()
	BC_Core.Message("BC_Editor.CryNew()", 2)
	BC_EditorUI.CryName.frame:SetText("")
	getglobal(BC_EditorUI.CryText.frame:GetName() .. "ScrollChildEditBox"):SetText("")
	BC_EditorUI.CryMult.frame:SetValue(1)
	BC_EditorUI.CryAlways.frame:SetChecked(0)
	BC_EditorUI.CryExclude.frame:SetChecked(0)
	BC_EditorUI.ConditionScroll.list = {}
	BC_Editor.Conditions_ButtonDisplay()
	BC_Editor.Conditions_New()
	UIDropDownMenu_SetSelectedValue(BC_EditorUI.CryLanguage.frame, 1)
	UIDropDownMenu_SetSelectedValue(BC_EditorUI.CryOutput.frame, 1)
	UIDropDownMenu_SetSelectedValue(BC_EditorUI.CryTiming.frame, 1)
	UIDropDownMenu_SetText(GetLanguageByIndex(1), BC_EditorUI.CryLanguage.frame)
	UIDropDownMenu_SetText(BC_UI.Variables.OutputModes[1], BC_EditorUI.CryOutput.frame)
	UIDropDownMenu_SetText(BC_UI.Variables.Timing[1], BC_EditorUI.CryTiming.frame)
end

function BC_Editor.CustomActionDelete()
	BC_Core.Message("BC_Editor.CustomActionDelete()", 2)
	table.remove(BC_Data.custom, BC_EditorUI.ActionScroll.selected)
	BC_Editor.SelectCategory(BC_EditorUI.CryCategoryScroll.selected)
end

function BC_Editor.CustomActionSave()
	BC_Core.Message("BC_Editor.CustomActionSave()", 2)
	text = BC_EditorUI.CustomName.frame:GetText()
	if(text ~= "") then
		found = false
		for k, v in pairs(BC_Data.custom) do
			if(v == text) then found = true end
		end
		if(found) then
			BC_Core.Message("Custom Action " .. text .. " already exists!")
		else
			BC_Core.Message("Saving Custom Action " .. text)
			table.insert(BC_Data.custom, text)
			BC_Editor.SelectCategory(BC_EditorUI.CryCategoryScroll.selected)
		end
	else
		BC_Core.Message("No name entered for custom action.")
	end
end

------------------------------------------------------
--
--	DrowDowns
--
------------------------------------------------------

function BC_Editor.LanguageDropDown_Initialize()
	local info = UIDropDownMenu_CreateInfo(); 
	tempList = {}
	for i=1, GetNumLanguages() do
		table.insert(tempList, GetLanguageByIndex(i))
	end
	BC_Editor.DropDown_Initialize(tempList)
end

function BC_Editor.OutputDropDown_Initialize()
	BC_Editor.DropDown_Initialize(BC_UI.Variables.OutputModes)
end

function BC_Editor.TimingDropDown_Initialize()
	BC_Editor.DropDown_Initialize(BC_UI.Variables.Timing)
end

function BC_Editor.TargetDropDown_Initialize()
	BC_Editor.DropDown_Initialize(BC_Vars.Condition.Targets)
end

function BC_Editor.TestDropDown_Initialize()
	BC_Editor.DropDown_Initialize(BC_Vars.Condition.Tests)
end

function BC_Editor.DropDown_Initialize(list)
	local info = UIDropDownMenu_CreateInfo(); 
	for i, v in pairs(list) do
		info.text = v
		info.value = i
		info.func = BC_Editor.DropDown_OnClick
		info.owner = this:GetParent()
		info.checked = nil
		UIDropDownMenu_AddButton(info)
	end
end

function BC_Editor.DropDown_OnClick()
	UIDropDownMenu_SetSelectedValue(this.owner, this.value)
end

------------------------------------------------------
--
--	Conditions
--
------------------------------------------------------

function BC_ConditionFrame_OnLoad()
	getglobal(this:GetName() .. "_TitleText"):SetText(BC_UI.Variables.Labels.Conditions)

	BC_EditorUI.ConditionTarget = BC_UI.DropDown:new("Target", BC_UI.Variables.Labels.Target, 80, BC_Editor.TargetDropDown_Initialize)
	BC_EditorUI.ConditionTarget.frame:SetPoint("TOPLEFT", this, "TOPLEFT", -5, -30)
	BC_EditorUI.ConditionTarget.frame:Show()

	BC_EditorUI.ConditionVariable = BC_UI.EditBox:new("Variable", BC_UI.Variables.Labels.Variable, "", 50)
	BC_EditorUI.ConditionVariable.frame:SetPoint("TOPLEFT", this, "TOPLEFT", 120, -27)
	BC_EditorUI.ConditionVariable.frame:SetMaxLetters(3)
	BC_EditorUI.ConditionVariable.frame:Show()

	BC_EditorUI.ConditionTest = BC_UI.DropDown:new("Test", BC_UI.Variables.Labels.Test, 50, BC_Editor.TestDropDown_Initialize)
	BC_EditorUI.ConditionTest.frame:SetPoint("TOPLEFT", this, "TOPLEFT", 165, -30)
	BC_EditorUI.ConditionTest.frame:Show()

	BC_EditorUI.ConditionValue = BC_UI.EditBox:new("Value", BC_UI.Variables.Labels.Value, "", 120)
	BC_EditorUI.ConditionValue.frame:SetPoint("TOPLEFT", this, "TOPLEFT", 260, -27)
	BC_EditorUI.ConditionValue.frame:Show()

	BC_EditorUI.ConditionScroll = BC_UI.ScrollPanel:new("Condition", 6, {})
	BC_EditorUI.ConditionScroll.frame:SetPoint("TOPLEFT", this, "TOPLEFT", 10, -60)
	BC_EditorUI.ConditionScroll.func = BC_Editor.Conditions_Select
	BC_EditorUI.ConditionScroll.frame:Show()
	BC_UI.ScrollList_SetWidth(BC_EditorUI.ConditionScroll, 295)
	BC_EditorUI.ConditionScroll.valueList = {}

	BC_EditorUI.ConditionDelete = BC_UI.Button:new("Delete", BC_UI.Variables.Labels.Delete, BC_Editor.Conditions_Delete)
	BC_EditorUI.ConditionDelete.frame:SetPoint("BOTTOMLEFT", BC_EditorUI.ConditionScroll.frame, "BOTTOMRIGHT", 0, 0)
	BC_EditorUI.ConditionDelete.frame:SetWidth(80)
	BC_EditorUI.ConditionDelete.frame:Hide()

	BC_EditorUI.ConditionAdd = BC_UI.Button:new("Add", BC_UI.Variables.Labels.Add, BC_Editor.Conditions_Add)
	BC_EditorUI.ConditionAdd.frame:SetPoint("TOPLEFT", BC_EditorUI.ConditionScroll.frame, "TOPRIGHT", 0, 0)
	BC_EditorUI.ConditionAdd.frame:SetWidth(80)
	BC_EditorUI.ConditionAdd.frame:Show()

	BC_EditorUI.ConditionNew = BC_UI.Button:new("New", BC_UI.Variables.Labels.New, BC_Editor.Conditions_New)
	BC_EditorUI.ConditionNew.frame:SetPoint("TOPLEFT", BC_EditorUI.ConditionScroll.frame, "BOTTOMLEFT", 0, -5)
	BC_EditorUI.ConditionNew.frame:SetWidth(80)
	BC_EditorUI.ConditionNew.frame:Show()

	BC_EditorUI.ConditionReturn = BC_UI.Button:new("Return", BC_UI.Variables.Labels.Return, BC_Editor.Conditions_Return)
	BC_EditorUI.ConditionReturn.frame:SetPoint("TOPLEFT", BC_EditorUI.ConditionNew.frame, "TOPRIGHT", 5, 0)
	BC_EditorUI.ConditionReturn.frame:SetWidth(80)
	BC_EditorUI.ConditionReturn.frame:Show()

	BC_EditorUI.ConditionCrySaveButton = BC_UI.Button:new("ConditionCrySave", BC_UI.Variables.Labels.Save, BC_Editor.Conditions_CrySave)
	BC_EditorUI.ConditionCrySaveButton.frame:SetPoint("BOTTOMRIGHT", this, "BOTTOMRIGHT", -15, 15)
	BC_EditorUI.ConditionCrySaveButton.frame:SetWidth(80)
	BC_EditorUI.ConditionCrySaveButton.frame:Show()

end

function BC_Editor.Conditions_Show()
	BC_Core.Message("BC_Editor.Conditions_Show()", 2)
	BC_EditorUI.CryName.frame:GetParent():Hide()
	BC_EditorUI.ConditionScroll.frame:GetParent():Show()
	BC_EditorUI.ConditionScroll.selected = 0
	BC_UI.ScrollList_UpdateList(getglobal(BC_EditorUI.ConditionScroll.frame:GetName() .. "Scroll"), BC_EditorUI.ConditionScroll.size, BC_EditorUI.ConditionScroll.list, #(BC_EditorUI.ConditionScroll.list), 0)
	BC_EditorUI.ConditionDelete.frame:Hide()
end

function BC_Editor.Conditions_ButtonDisplay()
	BC_Core.Message("BC_Editor.Conditions_ButtonDisplay()", 2)
	if(BC_EditorUI.ConditionScroll.list) then
		BC_EditorUI.CryConditionsButton.frame:SetText(BC_UI.Variables.Labels.Conditions .. " (" .. #(BC_EditorUI.ConditionScroll.list) .. ")")
	else
		BC_EditorUI.CryConditionsButton.frame:SetText(BC_UI.Variables.Labels.Conditions .. " (0)")
	end
end

function BC_Editor.GetConditions_List(conditions)
	BC_Core.Message("BC_Editor.GetConditions_List(...)", 2)
	local conditionList = {}
	local entry
	if(conditions) then
		for i=1, #(conditions) do
			entry = BC_Vars.Condition.Targets[conditions[i].target] .. " " .. BC_Vars.Condition.Variables[conditions[i].variable] .. " " .. BC_Vars.Condition.Tests[conditions[i].test] .. " " .. conditions[i].value
			table.insert(conditionList, entry)
		end
	end
	return conditionList
end

function BC_Editor.Conditions_Select(index)
	BC_Core.Message("BC_Editor.Conditions_Select(" .. index .. ")", 2)
	local condition = BC_EditorUI.ConditionScroll.valueList[index]
	
	UIDropDownMenu_SetSelectedValue(BC_EditorUI.ConditionTarget.frame, condition.target)
	UIDropDownMenu_SetText(BC_Vars.Condition.Targets[condition.target], BC_EditorUI.ConditionTarget.frame)

	UIDropDownMenu_SetSelectedValue(BC_EditorUI.ConditionTest.frame, condition.test)
	UIDropDownMenu_SetText(BC_Vars.Condition.Tests[condition.test], BC_EditorUI.ConditionTest.frame)

	BC_EditorUI.ConditionVariable.frame:SetText(BC_Vars.Condition.Variables[condition.variable])
	BC_EditorUI.ConditionValue.frame:SetText(condition.value)

	BC_EditorUI.ConditionDelete.frame:Show()
end

function BC_Editor.Conditions_New()
	BC_Core.Message("BC_Editor.Conditions_New()", 2)
	BC_EditorUI.ConditionScroll.selected = 0

	BC_UI.ScrollList_UpdateList(getglobal(BC_EditorUI.ConditionScroll.frame:GetName() .. "Scroll"), BC_EditorUI.ConditionScroll.size, BC_EditorUI.ConditionScroll.list, #(BC_EditorUI.ConditionScroll.list), 0)

	UIDropDownMenu_SetSelectedValue(BC_EditorUI.ConditionTarget.frame, 0)
	UIDropDownMenu_SetText("", BC_EditorUI.ConditionTarget.frame)

	UIDropDownMenu_SetSelectedValue(BC_EditorUI.ConditionTest.frame, 0)
	UIDropDownMenu_SetText("", BC_EditorUI.ConditionTest.frame)

	BC_EditorUI.ConditionVariable.frame:SetText("")
	BC_EditorUI.ConditionValue.frame:SetText("")

	BC_EditorUI.ConditionDelete.frame:Hide()
end

function BC_Editor.Conditions_Return()
	BC_Core.Message("BC_Editor.Conditions_Return()", 2)
	BC_EditorUI.CryName.frame:GetParent():Show()
	BC_EditorUI.ConditionScroll.frame:GetParent():Hide()
	BC_Editor.Conditions_ButtonDisplay()
end

function BC_Editor.Conditions_Delete()
	BC_Core.Message("BC_Editor.Conditions_Delete()", 2)
	table.remove(BC_EditorUI.ConditionScroll.list, BC_EditorUI.ConditionScroll.selected)
	table.remove(BC_EditorUI.ConditionScroll.valueList, BC_EditorUI.ConditionScroll.selected)
	BC_Editor.Conditions_Show()
end

function BC_Editor.Conditions_Add()
	BC_Core.Message("BC_Editor.Conditions_Add()", 2)
	local varNum = 0
	for i,v in ipairs(BC_Vars.Condition.Variables) do
		if(BC_EditorUI.ConditionVariable.frame:GetText()==v) then
			varNum = i
		end
	end
	if(varNum > 0) then
		local ltarget = UIDropDownMenu_GetSelectedValue(BC_EditorUI.ConditionTarget.frame)
		local ltest = UIDropDownMenu_GetSelectedValue(BC_EditorUI.ConditionTest.frame)
		local lvariable = varNum
		local lvalue = BC_EditorUI.ConditionValue.frame:GetText()
		table.insert(BC_EditorUI.ConditionScroll.list, BC_Vars.Condition.Targets[ltarget] .. " " .. BC_Vars.Condition.Variables[lvariable] .. " " .. BC_Vars.Condition.Tests[ltest] .. " " .. lvalue)
		table.insert(BC_EditorUI.ConditionScroll.valueList, {target = ltarget, variable = lvariable, test = ltest, value = lvalue,})
		BC_Core.Message("Saved successfully: " .. UIDropDownMenu_GetSelectedValue(BC_EditorUI.ConditionTarget.frame) .. " " .. BC_EditorUI.ConditionVariable.frame:GetText() .. " " .. UIDropDownMenu_GetSelectedValue(BC_EditorUI.ConditionTest.frame) .. " " .. BC_EditorUI.ConditionValue.frame:GetText(), 3)
		BC_Editor.Conditions_Show()
	end
end

function BC_Editor.Conditions_CrySave()
	BC_Core.Message("BC_Editor.Conditions_CrySave()", 2)
	BC_Editor.Conditions_Return()
	BC_Editor.CrySave()
end
------------------------------------------------------
--
--	Chains
--
------------------------------------------------------

function BC_EditorFrame_Chains_OnLoad()
	BC_EditorFrame_Chains_New()
end

function BC_EditorFrame_Chains_OnShow()
	BC_Core.Message("BC_EditorFrame_Chains_OnShow()", 2)
	BC_EditorUI.ChainSavedScroll.chains = BC_Editor.GetChains()
	BC_EditorUI.ChainSavedScroll.list = {}
	for i, v in ipairs(BC_EditorUI.ChainSavedScroll.chains) do
		local message = v.headAction .. "[" .. BC_Data.cries[v.headAction].cries[v.headCry].name .. "] -> " .. v.tailAction .. "[" .. BC_Data.cries[v.tailAction].cries[v.tailCry].name .. "]"
		table.insert(BC_EditorUI.ChainSavedScroll.list, message)
	end
	BC_UI.ScrollList_UpdateList(getglobal(BC_EditorUI.ChainSavedScroll.frame:GetName() .. "Scroll"), BC_EditorUI.ChainSavedScroll.size, BC_EditorUI.ChainSavedScroll.list, #(BC_EditorUI.ChainSavedScroll.list), 0)
end

function BC_EditorFrame_Chains_HeadFrame_OnLoad()
	getglobal(this:GetName() .. "_TitleText"):SetText("Head of Chain")

	BC_EditorUI.ChainHeadCategory = BC_UI.SubFrame:new("ChainHeadCategory", BC_UI.Variables.Labels.Categories, 190, 110)
	BC_EditorUI.ChainHeadCategory.frame:SetPoint("TOPLEFT", this, "TOPLEFT", 5, -18)
	BC_EditorUI.ChainHeadCategory.frame:Show()

	BC_EditorUI.ChainHeadAction = BC_UI.SubFrame:new("ChainHeadAction", BC_UI.Variables.Labels.Actions, 190, 110)
	BC_EditorUI.ChainHeadAction.frame:SetPoint("TOP", this, "TOP", 0, -18)
	BC_EditorUI.ChainHeadAction.frame:Show()

	BC_EditorUI.ChainHeadCry = BC_UI.SubFrame:new("ChainHeadCry", BC_UI.Variables.Labels.Cries, 190, 110)
	BC_EditorUI.ChainHeadCry.frame:SetPoint("TOPRIGHT", this, "TOPRIGHT", -5, -18)
	BC_EditorUI.ChainHeadCry.frame:Show()

	BC_EditorUI.ChainHeadCategoryScroll = BC_UI.ScrollPanel:new("ChainHeadCategory", 5, {}, BC_EditorFrame_Chains_SelectCategory)
	BC_EditorUI.ChainHeadCategoryScroll.frame:SetPoint("TOPLEFT", BC_EditorUI.ChainHeadCategory.frame, "TOPLEFT", 0, -10)
	BC_EditorUI.ChainHeadCategoryScroll.frame:Show()

	BC_EditorUI.ChainHeadActionScroll = BC_UI.ScrollPanel:new("ChainHeadAction", 5, {}, BC_EditorFrame_Chains_SelectAction)
	BC_EditorUI.ChainHeadActionScroll.frame:SetPoint("TOPLEFT", BC_EditorUI.ChainHeadAction.frame, "TOPLEFT", 0, -10)
	BC_EditorUI.ChainHeadActionScroll.frame:Show()

	BC_EditorUI.ChainHeadCryScroll = BC_UI.ScrollPanel:new("ChainHeadCry", 5, {}, BC_EditorFrame_Chains_SelectCry)
	BC_EditorUI.ChainHeadCryScroll.frame:SetPoint("TOPLEFT", BC_EditorUI.ChainHeadCry.frame, "TOPLEFT", 0, -10)
	BC_EditorUI.ChainHeadCryScroll.frame:Show()

	BC_EditorUI.ChainHeadCategoryScroll.list = BC_Editor.GetCategories()
	BC_Core.Message(this:GetName() .. " Loaded.", 3)
end

function BC_EditorFrame_Chains_TailFrame_OnLoad()
	getglobal(this:GetName() .. "_TitleText"):SetText("Tail of Chain")
	BC_EditorUI.ChainTailCategory = BC_UI.SubFrame:new("ChainTailCategory", BC_UI.Variables.Labels.Categories, 190, 110)
	BC_EditorUI.ChainTailCategory.frame:SetPoint("TOPLEFT", this, "TOPLEFT", 5, -18)
	BC_EditorUI.ChainTailCategory.frame:Show()

	BC_EditorUI.ChainTailAction = BC_UI.SubFrame:new("ChainTailAction", BC_UI.Variables.Labels.Actions, 190, 110)
	BC_EditorUI.ChainTailAction.frame:SetPoint("TOP", this, "TOP", 0, -18)
	BC_EditorUI.ChainTailAction.frame:Show()

	BC_EditorUI.ChainTailCry = BC_UI.SubFrame:new("ChainTailCry", BC_UI.Variables.Labels.Cries, 190, 110)
	BC_EditorUI.ChainTailCry.frame:SetPoint("TOPRIGHT", this, "TOPRIGHT", -5, -18)
	BC_EditorUI.ChainTailCry.frame:Show()

	BC_EditorUI.ChainTailCategoryScroll = BC_UI.ScrollPanel:new("ChainTailCategory", 5, {}, BC_EditorFrame_Chains_SelectCategory)
	BC_EditorUI.ChainTailCategoryScroll.frame:SetPoint("TOPLEFT", BC_EditorUI.ChainTailCategory.frame, "TOPLEFT", 0, -10)
	BC_EditorUI.ChainTailCategoryScroll.frame:Show()

	BC_EditorUI.ChainTailActionScroll = BC_UI.ScrollPanel:new("ChainTailAction", 5, {}, BC_EditorFrame_Chains_SelectAction)
	BC_EditorUI.ChainTailActionScroll.frame:SetPoint("TOPLEFT", BC_EditorUI.ChainTailAction.frame, "TOPLEFT", 0, -10)
	BC_EditorUI.ChainTailActionScroll.frame:Show()

	BC_EditorUI.ChainTailCryScroll = BC_UI.ScrollPanel:new("ChainTailCry", 5, {}, BC_EditorFrame_Chains_SelectCry)
	BC_EditorUI.ChainTailCryScroll.frame:SetPoint("TOPLEFT", BC_EditorUI.ChainTailCry.frame, "TOPLEFT", 0, -10)
	BC_EditorUI.ChainTailCryScroll.frame:Show()

	BC_EditorUI.ChainTailCategoryScroll.list = BC_Editor.GetCategories()
	BC_Core.Message(this:GetName() .. " Loaded.", 3)
end

function BC_EditorFrame_Chains_SavedFrame_OnLoad()

	getglobal(this:GetName() .. "_TitleText"):SetText("Saved Chains")
	BC_EditorUI.ChainSaved = BC_UI.SubFrame:new("ChainSaved", BC_UI.Variables.Labels.Categories, 500, 110)
	BC_EditorUI.ChainSaved.frame:SetPoint("TOPLEFT", this, "TOPLEFT", 5, -18)
	BC_EditorUI.ChainSaved.frame:Show()

	BC_EditorUI.ChainSavedScroll = BC_UI.ScrollPanel:new("ChainSaved", 5, {}, BC_EditorFrame_Chains_SelectSavedChain)
	BC_EditorUI.ChainSavedScroll.frame:SetPoint("TOPLEFT", BC_EditorUI.ChainSaved.frame, "TOPLEFT", 0, -10)
	BC_EditorUI.ChainSavedScroll.frame:Show()
	BC_UI.ScrollList_SetWidth(BC_EditorUI.ChainSavedScroll, 470)

	BC_EditorUI.ChainSave = BC_UI.Button:new("Save", BC_UI.Variables.Labels.Save, BC_EditorFrame_Chains_Save)
	BC_EditorUI.ChainSave.frame:SetPoint("BOTTOMRIGHT", this, "BOTTOMRIGHT", -10, 95)
	BC_EditorUI.ChainSave.frame:SetWidth(80)
	BC_EditorUI.ChainSave.frame:Show()

	BC_EditorUI.ChainDelete = BC_UI.Button:new("Delete", BC_UI.Variables.Labels.Delete, BC_EditorFrame_Chains_Delete)
	BC_EditorUI.ChainDelete.frame:SetPoint("BOTTOMRIGHT", this, "BOTTOMRIGHT", -10, 10)
	BC_EditorUI.ChainDelete.frame:SetWidth(80)
	BC_EditorUI.ChainDelete.frame:Show()

	BC_Core.Message(this:GetName() .. " Loaded.", 3)
end

function BC_EditorFrame_Chains_SelectCategory(index)
	BC_Core.Message("BC_EditorFrame_Chains_SelectCategory(" .. index .. ")",2);
	local headOrTail = string.sub(this:GetName(), string.len(this:GetParent():GetParent():GetName())+7, string.len(this:GetParent():GetParent():GetName()) + 10)
	local actionScroll = "Chain" .. headOrTail .. "ActionScroll"
	local cryScroll = "Chain" .. headOrTail .. "CryScroll"
	BC_EditorUI["Chain" .. headOrTail .. "CategoryScroll"].selected = index
	BC_EditorUI[actionScroll].list = BC_Editor.GetActions(BC_EditorUI["Chain" .. headOrTail .. "CategoryScroll"].list[index])
	BC_EditorUI[actionScroll].selected = 0
	BC_EditorUI[cryScroll].selected = 0
	BC_EditorUI[cryScroll].list = {}

	BC_UI.ScrollList_UpdateList(getglobal(BC_EditorUI[actionScroll].frame:GetName() .. "Scroll"), BC_EditorUI[actionScroll].size, BC_EditorUI[actionScroll].list, #(BC_EditorUI[actionScroll].list), 0)
	BC_UI.ScrollList_UpdateList(getglobal(BC_EditorUI[cryScroll].frame:GetName() .. "Scroll"), BC_EditorUI[cryScroll].size, BC_EditorUI[cryScroll].list, #(BC_EditorUI[cryScroll].list), 0)
end

function BC_EditorFrame_Chains_SelectAction(index)
	BC_Core.Message("BC_EditorFrame_Chains_SelectAction(" .. index .. ")",2);
	local headOrTail = string.sub(this:GetName(), string.len(this:GetParent():GetParent():GetName())+7, string.len(this:GetParent():GetParent():GetName()) + 10)
	local cryScroll = "Chain" .. headOrTail .. "CryScroll"
	BC_EditorUI["Chain" .. headOrTail .. "ActionScroll"].selected = index
	BC_EditorUI[cryScroll].list = BC_Editor.GetCries(BC_EditorUI["Chain" .. headOrTail .. "ActionScroll"].list[index])
	
	BC_UI.ScrollList_UpdateList(getglobal(BC_EditorUI[cryScroll].frame:GetName() .. "Scroll"), BC_EditorUI[cryScroll].size, BC_EditorUI[cryScroll].list, #(BC_EditorUI[cryScroll].list), 0)
end

function BC_EditorFrame_Chains_SelectCry(index)
	BC_Core.Message("BC_EditorFrame_Chains_SelectCry(" .. index .. ")",2);
	local headOrTail = string.sub(this:GetName(), string.len(this:GetParent():GetParent():GetName())+7, string.len(this:GetParent():GetParent():GetName()) + 10)
	BC_EditorUI["Chain" .. headOrTail .. "CryScroll"].selected = index
	BC_EditorFrame_Chains_SelectIfSaved()
end

function BC_EditorFrame_Chains_SelectSavedChain(index)
	BC_Core.Message("BC_EditorFrame_Chains_SelectSavedChain(" .. index .. ")", 2)
	for i, v in pairs(BC_Editor.GetCategories()) do
		for j, w in pairs(BC_Editor.GetActions(v)) do
			if(BC_EditorUI.ChainSavedScroll.chains[index].headAction == w) then
				BC_UI.ScrollList_Select(BC_EditorUI.ChainHeadCategoryScroll, i)
				BC_UI.ScrollList_Select(BC_EditorUI.ChainHeadActionScroll, j)
				BC_UI.ScrollList_Select(BC_EditorUI.ChainHeadCryScroll, BC_EditorUI.ChainSavedScroll.chains[index].headCry)
			end
			if(BC_EditorUI.ChainSavedScroll.chains[index].tailAction == w) then
				BC_UI.ScrollList_Select(BC_EditorUI.ChainTailCategoryScroll, i)
				BC_UI.ScrollList_Select(BC_EditorUI.ChainTailActionScroll, j)
				BC_UI.ScrollList_Select(BC_EditorUI.ChainTailCryScroll, BC_EditorUI.ChainSavedScroll.chains[index].tailCry)
			end
		end
	end
end

function BC_EditorFrame_Chains_New()
	BC_Core.Message("BC_EditorFrame_Chains_New()", 2)
end

function BC_EditorFrame_Chains_Save()
	BC_Core.Message("BC_EditorFrame_Chains_Save()", 2)
	local headNum = BC_EditorUI.ChainHeadActionScroll.selected
	local tailNum = BC_EditorUI.ChainTailActionScroll.selected
	BC_Core.Message(headNum .. " -> " .. tailNum, 3)
	local actionNameHead = BC_EditorUI.ChainHeadActionScroll.list[headNum]
	local actionNameTail = BC_EditorUI.ChainTailActionScroll.list[tailNum]
	BC_Core.Message(actionNameHead .. " -> " .. actionNameTail, 3)
	if(not BC_Data.cries[actionNameHead].cries[BC_EditorUI.ChainHeadCryScroll.selected].chain) then
		BC_Data.cries[actionNameHead].cries[BC_EditorUI.ChainHeadCryScroll.selected].chain = {}
	end
	if(not BC_Data.cries[actionNameHead].cries[BC_EditorUI.ChainHeadCryScroll.selected].chain[actionNameTail]) then
		BC_Data.cries[actionNameHead].cries[BC_EditorUI.ChainHeadCryScroll.selected].chain[actionNameTail] = {BC_EditorUI.ChainTailCryScroll.selected,}
	else
		table.insert(BC_Data.cries[actionNameHead].cries[BC_EditorUI.ChainHeadCryScroll.selected].chain[actionNameTail], BC_EditorUI.ChainTailCryScroll.selected)
	end
	BC_EditorFrame_Chains_OnShow()
	BC_EditorFrame_Chains_SelectIfSaved()
end

function BC_EditorFrame_Chains_Delete()
	BC_Core.Message("BC_EditorFrame_Chains_Delete()", 2)
	local v = BC_EditorUI.ChainSavedScroll.chains[BC_EditorUI.ChainSavedScroll.selected]
	table.remove(BC_Data.cries[v.headAction].cries[v.headCry].chain[v.tailAction], v.tailCry)
	BC_EditorFrame_Chains_OnShow()
end

function BC_EditorFrame_Chains_SelectIfSaved()
	BC_Core.Message("BC_EditorFrame_Chains_SelectIfSaved()", 2)
	local found = false
	for i, v in pairs(BC_EditorUI.ChainSavedScroll.chains) do
		if(v.headAction == BC_EditorUI.ChainHeadActionScroll.list[BC_EditorUI.ChainHeadActionScroll.selected]) then
			if(v.tailAction == BC_EditorUI.ChainTailActionScroll.list[BC_EditorUI.ChainTailActionScroll.selected]) then
				if(v.headCry == BC_EditorUI.ChainHeadCryScroll.selected) then
					if(v.tailCry == BC_EditorUI.ChainTailCryScroll.selected) then
						BC_Core.Message("Found selected #" .. i, 3)
						found = true
						BC_UI.ScrollList_Select(BC_EditorUI.ChainSavedScroll, i)
					end
				end
			end
		end
	end
	if(found==false) then
		BC_Core.Message("Not found", 3)
	BC_UI.ScrollList_UpdateList(getglobal(BC_EditorUI.ChainSavedScroll.frame:GetName() .. "Scroll"), BC_EditorUI.ChainSavedScroll.size, BC_EditorUI.ChainSavedScroll.list, #(BC_EditorUI.ChainSavedScroll.list), 0)
	end
end
------------------------------------------------------
--
--	Events
--
------------------------------------------------------
function BC_EditorFrame_Events_OnLoad()
	BC_Core.Message("BC_EditorFrame_Events_OnLoad()", 2)

	BC_EditorUI.OpenWatchButton = BC_UI.Button:new("OpenWatch", BC_UI.Variables.Labels.OpenWatch, BC_EditorFrame_Events_OpenWatch)
	BC_EditorUI.OpenWatchButton.frame:SetPoint("BOTTOMRIGHT", this, "BOTTOMRIGHT", -50, 55)
	BC_EditorUI.OpenWatchButton.frame:SetWidth(120)
	BC_EditorUI.OpenWatchButton.frame:Show()

end

function BC_EditorFrame_Events_OnShow()
	BC_Core.Message("BC_EditorFrame_Events_OnShow()", 2)

	BC_EditorUI.EventWatchScroll.list = {}

	for k, v in pairs(BC_Data.events) do
		for i, w in ipairs(v) do
			table.insert(BC_EditorUI.EventWatchScroll.list, w.name)
		end
	end
	BC_UI.ScrollList_UpdateList(getglobal(BC_EditorUI.EventWatchScroll.frame:GetName() .. "Scroll"), BC_EditorUI.EventWatchScroll.size, BC_EditorUI.EventWatchScroll.list, #(BC_EditorUI.EventWatchScroll.list), 0)
end

function BC_EditorFrame_Events_NewFrame_OnLoad()
	BC_Core.Message("BC_EditorFrame_Events_NewFrame_OnLoad()", 2)
	getglobal(this:GetName() .. "_TitleText"):SetText("Save New Watch")

	BC_EditorUI.EventWatchTitle = BC_UI.EditBox:new("WatchText", "Watch Name", "", 160)
	BC_EditorUI.EventWatchTitle.frame:SetPoint("TOPLEFT", this, "TOPLEFT", 15, -30)
	BC_EditorUI.EventWatchTitle.frame:Show()
	BC_EditorUI.EventWatchTitle.frame:SetScript("OnTextChanged", BC_EditorFrame_Events_TitleChange)
	BC_EditorUI.EventWatchTitle.frame:SetScript("OnEnterPressed", BC_EditorFrame_Events_SavedSave)

	BC_EditorUI.EventWatchSave = BC_UI.Button:new("WatchSave", BC_UI.Variables.Labels.Save, BC_EditorFrame_Events_SavedSave)
	BC_EditorUI.EventWatchSave.frame:SetPoint("TOPLEFT", BC_EditorUI.EventWatchTitle.frame, "BOTTOMLEFT", -5, 0)
	BC_EditorUI.EventWatchSave.frame:SetWidth(80)
	BC_EditorUI.EventWatchSave.frame:Hide()

end

function BC_EditorFrame_Events_SavedFrame_OnLoad()
	BC_Core.Message("BC_EditorFrame_Events_SavedFrame_OnLoad()", 2)
	getglobal(this:GetName() .. "_TitleText"):SetText("Saved Event Watches")

	BC_Events.Initialize()
	BC_EditorUI.EventWatchScroll = BC_UI.ScrollPanel:new("EventWatch", 15, {}, BC_EditorFrame_Events_SelectSaved)
	BC_EditorUI.EventWatchScroll.frame:SetPoint("TOPLEFT", this, "TOPLEFT", 0, -10)
	BC_EditorUI.EventWatchScroll.frame:Show()
	BC_UI.ScrollList_SetWidth(BC_EditorUI.EventWatchScroll, 169)

	BC_EditorUI.EventWatchDelete = BC_UI.Button:new("WatchDelete", BC_UI.Variables.Labels.Delete, BC_EditorFrame_Events_SavedDelete)
	BC_EditorUI.EventWatchDelete.frame:SetPoint("TOPLEFT", BC_EditorUI.EventWatchScroll.frame, "BOTTOMLEFT", 10, -5)
	BC_EditorUI.EventWatchDelete.frame:SetWidth(80)
	BC_EditorUI.EventWatchDelete.frame:Hide()
end

function BC_EditorFrame_Events_AvailableFrame_OnLoad()
	BC_Core.Message("BC_EditorFrame_Events_AvailableFrame_OnLoad()", 2)
	getglobal(this:GetName() .. "_TitleText"):SetText("Available Events")

	BC_EditorUI.EventsAvailableScroll = BC_UI.ScrollPanel:new("EventsAvailable", 11, BC_UI.Variables.Events, BC_EditorFrame_Events_SelectAvailable)
	BC_EditorUI.EventsAvailableScroll.frame:SetPoint("TOPLEFT", this, "TOPLEFT", 0, -10)
	BC_EditorUI.EventsAvailableScroll.frame:Show()
	BC_UI.ScrollList_SetWidth(BC_EditorUI.EventsAvailableScroll, 369)
end

function BC_EditorFrame_Events_ArgsFrame_OnLoad()
	BC_Core.Message("BC_EditorFrame_Events_ArgsFrame_OnLoad()", 2)
	getglobal(this:GetName() .. "_TitleText"):SetText("Arguments")
	BC_Core.Message(this:GetName(), 4)
	BC_EditorUI.EventsArgs = {}
	BC_EditorUI.EventsArgs.ArgText = {}
	BC_EditorUI.EventsArgs.SaveButton = {}
	BC_EditorUI.EventsArgs.DeleteButton = {}
	for i = 1, 5 do
		BC_EditorUI.EventsArgs.ArgText[i] = BC_UI.EditBox:new("Text" .. i, "", "", 205)
		BC_EditorUI.EventsArgs.ArgText[i].frame:SetPoint("TOPLEFT", this, "TOPLEFT", 15, (i * -27) + 5)

		BC_EditorUI.EventsArgs.SaveButton[i] = BC_UI.Button:new("Save" .. i, BC_UI.Variables.Labels.Add, BC_EditorFrame_Events_ArgsSave)
		BC_EditorUI.EventsArgs.SaveButton[i].frame:SetPoint("LEFT", BC_EditorUI.EventsArgs.ArgText[i].frame, "RIGHT", 10, -0)
		BC_EditorUI.EventsArgs.SaveButton[i].frame:SetWidth(80)

		BC_EditorUI.EventsArgs.DeleteButton[i] = BC_UI.Button:new("Delete" .. i, BC_UI.Variables.Labels.Add, BC_EditorFrame_Events_ArgsDelete)
		BC_EditorUI.EventsArgs.DeleteButton[i].frame:SetPoint("LEFT", BC_EditorUI.EventsArgs.SaveButton[i].frame, "RIGHT", 5, -0)
		BC_EditorUI.EventsArgs.DeleteButton[i].frame:SetWidth(80)
	end
	BC_EditorUI.EventsArgs.Num = 0
	BC_EditorUI.EventsArgs.Args = {}
	BC_EditorFrame_Events_ArgsDisplay()
end

function BC_EditorFrame_Events_SelectSaved(index)
	BC_Core.Message("BC_EditorFrame_Events_SelectSaved(" .. index .. ")", 2)
	local found = ""
	for k, v in pairs(BC_Data.events) do
		for i, w in ipairs(v) do
			if(BC_EditorUI.EventWatchScroll.list[index] == w.name) then
				found = k
				if(w.args) then
					BC_EditorUI.EventsArgs.Args = {}
					for l, u in ipairs(w.args) do
						BC_EditorUI.EventsArgs.Args[l] = u
					end
					BC_EditorUI.EventsArgs.Num = #(w.args)
				else
					BC_EditorUI.EventsArgs.Args = {}
					BC_EditorUI.EventsArgs.Num = 0
				end
			end
		end
	end
	for i, v in ipairs(BC_EditorUI.EventsAvailableScroll.list) do
		if(found == v) then
			BC_UI.ScrollList_Select(BC_EditorUI.EventsAvailableScroll, i)
		end
	end
	BC_EditorUI.EventWatchDelete.frame:Show()
	BC_EditorUI.EventWatchTitle.frame:SetText(BC_EditorUI.EventWatchScroll.list[index])
	BC_EditorFrame_Events_ArgsDisplay()
end

function BC_EditorFrame_Events_SelectAvailable(index)
	BC_Core.Message("BC_EditorFrame_Events_SelectAvailable(" .. index .. ")", 2)
	if(index > 0) then
		BC_EditorUI.EventWatchSave.frame:Show()
	else
		BC_EditorUI.EventWatchSave.frame:Hide()
	end
end

function BC_EditorFrame_Events_ArgsDisplay()
	BC_Core.Message("BC_EditorFrame_Events_ArgsDisplay()", 2)
	height = 32.5
	for i = 1, 5 do
		if(i < BC_EditorUI.EventsArgs.Num + 1) then
			BC_EditorUI.EventsArgs.ArgText[i].frame:Show()
			BC_EditorUI.EventsArgs.ArgText[i].frame:SetText(BC_EditorUI.EventsArgs.Args[i])
			BC_EditorUI.EventsArgs.SaveButton[i].frame:Show()
			BC_EditorUI.EventsArgs.SaveButton[i].frame:SetText("Save");
			BC_EditorUI.EventsArgs.DeleteButton[i].frame:Show()
			BC_EditorUI.EventsArgs.DeleteButton[i].frame:SetText("Delete");
			height = height + 27.5
		elseif(i == BC_EditorUI.EventsArgs.Num + 1) then
			BC_EditorUI.EventsArgs.ArgText[i].frame:Show()
			BC_EditorUI.EventsArgs.ArgText[i].frame:SetText("")
			BC_EditorUI.EventsArgs.SaveButton[i].frame:Show()
			BC_EditorUI.EventsArgs.SaveButton[i].frame:SetText("Add");
			BC_EditorUI.EventsArgs.DeleteButton[i].frame:Hide()
			height = height + 27.5
		else
			BC_EditorUI.EventsArgs.ArgText[i].frame:Hide()
			BC_EditorUI.EventsArgs.DeleteButton[i].frame:Hide()
			BC_EditorUI.EventsArgs.SaveButton[i].frame:Hide()
		end
	end
	BC_EditorFrame_Events_ArgsFrame:SetHeight(height)
end

function BC_EditorFrame_Events_ArgsDelete()
	BC_Core.Message("BC_EditorFrame_Events_ArgsDelete()", 2)
	num = string.sub(this:GetName(), -7, -7)
	for i = num, BC_EditorUI.EventsArgs.Num - 1 do
		BC_EditorUI.EventsArgs.Args[i] = BC_EditorUI.EventsArgs.Args[i+1]
	end
	BC_EditorUI.EventsArgs.Args[num] = nil
	BC_EditorUI.EventsArgs.Num = BC_EditorUI.EventsArgs.Num - 1
	BC_EditorFrame_Events_ArgsDisplay()
end

function BC_EditorFrame_Events_ArgsSave()
	BC_Core.Message("BC_EditorFrame_Events_ArgsSave()", 2)
	num = tonumber(string.sub(this:GetName(), -7, -7))
	if(num > BC_EditorUI.EventsArgs.Num) then
		if(BC_EditorUI.EventsArgs.ArgText[num].frame:GetText() ~= "") then
			BC_EditorUI.EventsArgs.Args[num] = BC_EditorUI.EventsArgs.ArgText[num].frame:GetText()
			BC_EditorUI.EventsArgs.Num = num
		end
	else
		if(BC_EditorUI.EventsArgs.ArgText[num].frame:GetText() == "") then
			BC_EditorUI.EventsArgs.DeleteButton[num].frame:Click()
		else
			BC_EditorUI.EventsArgs.Args[num] = BC_EditorUI.EventsArgs.ArgText[num].frame:GetText()
		end
	end
	BC_EditorFrame_Events_ArgsDisplay()
end

function BC_EditorFrame_Events_SavedSave()
	BC_Core.Message("BC_EditorFrame_Events_SavedSave()", 2)
	watchName = BC_EditorUI.EventWatchTitle.frame:GetText()
	BC_Core.Message(watchName, 3)
	if(watchName ~= "") then
		eventName = BC_EditorUI.EventsAvailableScroll.list[BC_EditorUI.EventsAvailableScroll.selected]
		if(eventName) then
			BC_Core.Message(tostring(eventName), 3)
			if(BC_Data.events[eventName]) then
				if(BC_EditorUI.EventsArgs.ArgText[BC_EditorUI.EventsArgs.Num + 1].frame:GetText() ~= "") then
					BC_EditorUI.EventsArgs.SaveButton[BC_EditorUI.EventsArgs.Num + 1].frame:Click()
				end
				BC_Core.Message(eventName .. " exists", 3)
				found = false
				for i, v in ipairs(BC_Data.events[eventName]) do
					if(v.name == watchName) then
						BC_Core.Message(watchName .. " exists", 3)
						BC_Data.events[eventName][i] = { name = watchName, args = BC_EditorUI.EventsArgs.Args, }
						found = true
					end
				end
				if(not found) then
					BC_Core.Message(watchName .. " does not exist", 3)
					table.insert(BC_Data.events[eventName], { name = watchName, args = BC_EditorUI.EventsArgs.Args, })
				end
			else
				BC_Core.Message(tostring(eventName) .. " does not exist.", 3)
				BC_Data.events[eventName] = { [1] = { ["name"] = watchName, args = BC_EditorUI.EventsArgs.Args, }, }
			end
		end
	end
	BC_EditorFrame_Events_OnShow()
end

function BC_EditorFrame_Events_SavedDelete()
	BC_Core.Message("BC_EditorFrame_Events_SavedDelete()", 2)
	BC_Core.Message(BC_EditorUI.EventWatchScroll.selected, 3)
	BC_Core.Message(BC_EditorUI.EventWatchScroll.list[BC_EditorUI.EventWatchScroll.selected], 3)
	for k, v in pairs(BC_Data.events) do
		for i, w in ipairs(v) do
			if(BC_EditorUI.EventWatchScroll.list[BC_EditorUI.EventWatchScroll.selected] == w.name) then
				table.remove(BC_Data.events[k], i)
			end
		end
	end
	BC_EditorUI.EventWatchDelete.frame:Hide()
	BC_EditorFrame_Events_OnShow()
end

function BC_EditorFrame_Events_OpenWatch()
	BC_Core.Message("BC_EditorFrame_Events_OpenWatch()", 2)
	BC_EventWatchFrame:Show()
end

function BC_EditorFrame_Events_TitleChange()
	BC_Core.Message("BC_EditorFrame_Events_TitleChange()", 2)
	if(BC_EditorUI.EventWatchTitle.frame:GetText() ~= "") then
		BC_EditorUI.EventWatchSave.frame:Show()
	else
		BC_EditorUI.EventWatchSave.frame:Hide()
	end
end
------------------------------------------------------
--
--	UI
--
------------------------------------------------------

function BC_Editor.Tab_OnClick()
	BC_Core.Message("BC_Editor.Tab_OnClick()", 2);
	PanelTemplates_Tab_OnClick(BC_EditorFrame);
	BC_Core.Message(this:GetName(),4);
	if(this:GetID()==3) then
		BC_Core.Message("Showing Cries", 3)
		BC_EditorFrame_Cries:Show()
		BC_EditorFrame_Chains:Hide()
		BC_EditorFrame_Events:Hide()
	elseif(this:GetID()==2) then
		BC_Core.Message("Showing Chains", 3)
		BC_EditorFrame_Cries:Hide()
		BC_EditorFrame_Chains:Show()
		BC_EditorFrame_Events:Hide()
	elseif(this:GetID()==1) then
		BC_Core.Message("Showing Events", 3)
		BC_EditorFrame_Cries:Hide()
		BC_EditorFrame_Chains:Hide()
		BC_EditorFrame_Events:Show()
	end
end

function BC_EditorFrame_Tooltip_Set()
	BC_Core.Message("Set tooltip for " .. this:GetName(), 5)
end

function BC_EditorFrame_Tooltip_Unset()
	BC_Core.Message("Unset tooltip for " .. this:GetName(), 5)

end