BC_EventWatch = {}
BC_EventWatch.WatchStatus = "waiting"
BC_EventWatch.CapturedEvents = {}

function BC_EventWatchFrame_OnLoad()
	getglobal(this:GetName() .. "_TitleText"):SetText(BC_Vars.Title)

	BC_EditorUI.ToggleButton = BC_UI.Button:new("Toggle", BC_UI.Variables.Labels.Start, BC_EventWatch.ToggleWatch)
	BC_EditorUI.ToggleButton.frame:SetPoint("TOPLEFT", this, "TOPLEFT", 5, -15)
	BC_EditorUI.ToggleButton.frame:SetWidth(65)
	BC_EditorUI.ToggleButton.frame:Show()

	BC_EditorUI.ResetButton = BC_UI.Button:new("Reset", BC_UI.Variables.Labels.Reset, BC_EventWatch.Reset)
	BC_EditorUI.ResetButton.frame:SetPoint("TOPLEFT", BC_EditorUI.ToggleButton.frame, "TOPRIGHT", 5, 0)
	BC_EditorUI.ResetButton.frame:SetWidth(80)
	BC_EditorUI.ResetButton.frame:Show()

	BC_EditorUI.SendButton = BC_UI.Button:new("Send", BC_UI.Variables.Labels.SendWatch, BC_EventWatch.SendWatch)
	BC_EditorUI.SendButton.frame:SetPoint("TOPLEFT", BC_EditorUI.ResetButton.frame, "TOPRIGHT", 5, 0)
	BC_EditorUI.SendButton.frame:SetWidth(200)
	BC_EditorUI.SendButton.frame:Hide()

	BC_EditorUI.CapturedEventsScroll = BC_UI.ScrollPanel:new("CapturedEvents", 11, BC_EventWatch.CapturedEvents, BC_EventWatch.SelectEvent)
	BC_EditorUI.CapturedEventsScroll.frame:SetPoint("TOPLEFT", this, "TOPLEFT", 0, -30)
	BC_EditorUI.CapturedEventsScroll.frame:Show()
	BC_UI.ScrollList_SetWidth(BC_EditorUI.CapturedEventsScroll, 360)
	
	BC_EditorUI.CapturedArgs = {}
	for i = 1, 9 do
		BC_EditorUI.CapturedArgs[i] = BC_UI.EditBox:new("Text" .. i, "Argument " .. i, "", 355)
		BC_EditorUI.CapturedArgs[i].frame:SetPoint("TOP", BC_EditorUI.CapturedEventsScroll.frame, "BOTTOM", 15, (i * -35) + 30)
		BC_EditorUI.CapturedArgs[i].frame:Show()
	end

	BC_EventWatch.Refresh()
	BC_Core.Message(BC_Vars.AddOnName .. " Event Watcher Loaded.")
end

function BC_EventWatchFrame_OnHide()
	BC_Core.Message("BC_EventWatchFrame_OnHide()", 2)
end

function BC_EventWatchFrame_OnEvent()
	BC_Core.Message("BC_EventWatchFrame_OnEvent(" .. event .. ")", 3)
	argVals = {}
	for i = 1, 9 do
		if(getglobal("arg" .. i) ~= nil) then
			table.insert(argVals, getglobal("arg" .. i))
		end
	end
	table.insert(BC_EventWatch.CapturedEvents, { ["event"] = event, ["args"] = argVals, })
	if(BC_EventWatchFrame:IsVisible()) then
		BC_EventWatch.Refresh()
	end
end

function BC_EventWatch.Refresh()
	BC_Core.Message("BC_EventWatch.Refresh()", 2)
	if(BC_EventWatch.WatchStatus == "watching") then
		BC_EditorUI.CapturedEventsScroll.list = { "watching...",}
		for i=1, 9 do
			BC_EditorUI.CapturedArgs[i].frame:Hide()
		end
		BC_EditorUI.SendButton.frame:Hide()
		BC_EditorUI.ResetButton.frame:Hide()
		BC_EventWatchFrame:SetHeight(65)
	else
		if(#(BC_EventWatch.CapturedEvents) > 0) then
			BC_EditorUI.ResetButton.frame:Show()
			BC_EventWatchFrame:SetHeight(225)
		else
			BC_EditorUI.ResetButton.frame:Hide()
			BC_EventWatchFrame:SetHeight(65)
		end
		BC_EditorUI.CapturedEventsScroll.list = {}
		for k, v in ipairs(BC_EventWatch.CapturedEvents) do
			table.insert(BC_EditorUI.CapturedEventsScroll.list, v.event)
		end
		if(BC_EditorUI.CapturedEventsScroll.selected > 0) then
			BC_EditorUI.SendButton.frame:Show()
			BC_Core.Message(BC_EditorUI.CapturedEventsScroll.list[BC_EditorUI.CapturedEventsScroll.selected], 3)
			empty = false
			for i=1, #(BC_EventWatch.CapturedEvents[BC_EditorUI.CapturedEventsScroll.selected].args) do
				if(not empty) then
					if(BC_EventWatch.CapturedEvents[BC_EditorUI.CapturedEventsScroll.selected].args[i] == "" or BC_EventWatch.CapturedEvents[BC_EditorUI.CapturedEventsScroll.selected].args[i] == 0) then
						empty = true
						BC_EditorUI.CapturedArgs[i].frame:Hide()
					else
						BC_EditorUI.CapturedArgs[i].frame:Show()
						BC_EventWatchFrame:SetHeight(BC_EventWatchFrame:GetHeight() + 35)
						BC_EditorUI.CapturedArgs[i].frame:SetText(BC_EventWatch.CapturedEvents[BC_EditorUI.CapturedEventsScroll.selected].args[i])
					end
				else
					BC_EditorUI.CapturedArgs[i].frame:Hide()
				end
			end
			if(#(BC_EventWatch.CapturedEvents[BC_EditorUI.CapturedEventsScroll.selected].args) < 9) then
				for i=#(BC_EventWatch.CapturedEvents[BC_EditorUI.CapturedEventsScroll.selected].args)+1, 9 do
					BC_EditorUI.CapturedArgs[i].frame:Hide()
				end
			end
		else
			for i=1, 9 do
				BC_EditorUI.CapturedArgs[i].frame:Hide()
			end
		end
	end
	BC_UI.ScrollList_UpdateList(getglobal(BC_EditorUI.CapturedEventsScroll.frame:GetName() .. "Scroll"), BC_EditorUI.CapturedEventsScroll.size, BC_EditorUI.CapturedEventsScroll.list, #(BC_EditorUI.CapturedEventsScroll.list), 0)
end

function BC_EventWatch.SelectEvent(index)
	BC_Core.Message("BC_EventWatch.SelectEvent(" .. index .. ")", 2)
	BC_EventWatch.Refresh()
end

function BC_EventWatch.ToggleWatch()
	BC_Core.Message("BC_EventWatch.ToggleWatch()", 2)
	if(BC_EventWatch.WatchStatus == "waiting") then
		BC_EditorUI.ToggleButton.frame:SetText("Stop")
		BC_EventWatch.WatchStatus = "watching"
		BC_Core.Message(this:GetParent():GetName(), 3)
		for i, v in ipairs(BC_UI.Variables.Events) do
			this:GetParent():RegisterEvent(v)
		end
	else
		BC_EditorUI.ToggleButton.frame:SetText("Start")
		BC_EventWatch.WatchStatus = "waiting"
		for i, v in ipairs(BC_UI.Variables.Events) do
			this:GetParent():UnregisterEvent(v)
		end
	end
	BC_EventWatch.Refresh()
end

function BC_EventWatch.SendWatch()
	BC_Core.Message("BC_EventWatch.SendWatch()", 2)
	selectedEvent = BC_EventWatch.CapturedEvents[BC_EditorUI.CapturedEventsScroll.selected].event
	BC_Core.Message(selectedEvent, 3)
	for i=1, #(BC_EditorUI.EventsAvailableScroll.list) do
		if(selectedEvent == BC_EditorUI.EventsAvailableScroll.list[i]) then
			BC_UI.ScrollList_Select(BC_EditorUI.EventsAvailableScroll, i)
			BC_EditorUI.EventsArgs.Args = {}
			BC_EditorUI.EventsArgs.Num = 0
			for j=1, 5 do
				--BC_Core.Message(BC_EventWatch.CapturedEvents[BC_EditorUI.CapturedEventsScroll.selected].args[j], 4)
				if(BC_EventWatch.CapturedEvents[BC_EditorUI.CapturedEventsScroll.selected].args[j]) then
					if(BC_EventWatch.CapturedEvents[BC_EditorUI.CapturedEventsScroll.selected].args[j] ~= "" and BC_EventWatch.CapturedEvents[BC_EditorUI.CapturedEventsScroll.selected].args[j] ~= 0) then
						BC_EditorUI.EventsArgs.Args[j] = BC_EventWatch.CapturedEvents[BC_EditorUI.CapturedEventsScroll.selected].args[j]
						BC_EditorUI.EventsArgs.Num = j
					end
				end
			end
			BC_EditorUI.EventWatchTitle.frame:SetText("")
			BC_EditorFrame_Events_ArgsDisplay()
		end
	end
	BC_EditorFrame:Show()
end

function BC_EventWatch.Reset()
	BC_Core.Message("BC_EventWatch.Reset()", 2)
	BC_EventWatch.CapturedEvents = {}
	BC_EditorUI.CapturedEventsScroll.selected = 0
	BC_EventWatch.Refresh()
end